#property copyright "Copyright 2022, MetaQuotes Ltd."
#property link      "https://www.mql5.com"
#property version   "1.00"
#include <Trade\Trade.mqh>
#include <Trade\PositionInfo.mqh>
#include <Trade\SymbolInfo.mqh>
CTrade trade;
CSymbolInfo symbolInfo;

input int limitOrderRange = 20; // Distance to limit order
input int tp = 100;
input int sl = 100;
input int MagicNumber = 20220903;
double finalLot = SymbolInfoDouble(_Symbol, SYMBOL_VOLUME_MIN);

int OnInit()
{
   trade.SetExpertMagicNumber(MagicNumber);
   return(INIT_SUCCEEDED);
}

void OnTick()
{
   double Ask = symbolInfo.NormalizePrice(SymbolInfoDouble(_Symbol, SYMBOL_ASK));
   double margin_required = 0;
   OrderCalcMargin(ORDER_TYPE_BUY, _Symbol, finalLot, Ask, margin_required);
   
   if (!OrdersTotal() && margin_required*2 <= AccountInfoDouble(ACCOUNT_FREEMARGIN))
   {
      symbolInfo.Name(_Symbol);
      double point = SymbolInfoDouble(_Symbol, SYMBOL_POINT);
      double limit_order_range = MathMax(limitOrderRange, SymbolInfoInteger(_Symbol, SYMBOL_TRADE_FREEZE_LEVEL));
      trade.BuyLimit(finalLot, symbolInfo.NormalizePrice(Ask-limit_order_range*point), _Symbol, symbolInfo.NormalizePrice(Ask-sl*point), symbolInfo.NormalizePrice(Ask+tp*point), ORDER_TIME_GTC, 0, "");
   }
}